package org.hso.ecommerce.action.cronjob;

import java.util.Calendar;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class Reorder implements ICronjob {
    private static final Logger log = LoggerFactory.getLogger(Reorder.class);

    @Override
    public Calendar nextExecution(Calendar reference) {
        if (reference.get(Calendar.HOUR_OF_DAY) >= 8) {
            reference.add(Calendar.DAY_OF_MONTH, 1);
        }
        reference.set(Calendar.HOUR_OF_DAY, 8);
        reference.set(Calendar.MINUTE, 0);
        reference.set(Calendar.SECOND, 0);
        reference.set(Calendar.MILLISECOND, 0);
        return reference;
    }

    @Override
    public Calendar previousExecution(Calendar reference) {
        if (reference.get(Calendar.HOUR_OF_DAY) < 8) {
            reference.add(Calendar.DAY_OF_MONTH, -1);
        }
        reference.set(Calendar.HOUR_OF_DAY, 8);
        reference.set(Calendar.MINUTE, 0);
        reference.set(Calendar.SECOND, 0);
        reference.set(Calendar.MILLISECOND, 0);
        return reference;
    }

    @Override
    public void executeAt(Calendar time) {
        log.info("Executing Reorder Cronjob");
    }
}
